package com.javacodegeeks.examples.comparable;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

public class ComparableDemo {
    public static void main(String[] args) {
        sortingArraysAndWrapperClass();
        sortingArraysAndUserDefinedClass();

    }

    private static void sortingArraysAndUserDefinedClass() {

        //Sorting array of Employee objects using Arrays.sort()
        Employee[] employees = {new Employee(1, "Pat", 1000.0),
                new Employee(2, "Lesa", 2500.0),
                new Employee(3, "Jackie", 1500.0),
                new Employee(4, "Charles", 6000.0)};
        System.out.println("Employee array before sorting: " + Arrays.toString(employees));
        Arrays.sort(employees);
        System.out.println("Employee array after sorting: " + Arrays.toString(employees));

        //Sorting List of Employee objects Collections.sort()
        List<Employee> employeeList = Arrays.asList(new Employee(1, "Pat", 1000.0),
                new Employee(2, "Lesa", 2500.0),
                new Employee(3, "Jackie", 1500.0),
                new Employee(4, "Charles", 6000.0));
        System.out.println("Employee list before sorting: " + employeeList);
        Arrays.sort(employees);
        System.out.println("Employee list after sorting: " + employeeList);
    }

    private static void sortingArraysAndWrapperClass() {

        //Sorting array of integers using Arrays.sort()
        int[] arr = {8, 5, 1, 4, 7, 9, 2, 3, 6, 0};
        System.out.println("Integer array before sorting: " + Arrays.toString(arr));
        Arrays.sort(arr);
        System.out.println("Integer array after sorting: " + Arrays.toString(arr));

        //Sorting array of Strings using Arrays.sort()
        String[] names = {"Pat", "Lesa", "Jackie", "Charles"};
        System.out.println("String array before sorting: " + Arrays.toString(names));
        Arrays.sort(names);
        System.out.println("String array after sorting: " + Arrays.toString(names));

        //Sorting List of String Collections.sort()
        List<String> fruits = Arrays.asList("Orange", "Banana", "Apple", "Guava", "Grapes");
        System.out.println("String list before sorting: " + fruits);
        Collections.sort(fruits);
        System.out.println("String list after sorting: " + fruits);
    }
}

